<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NNICapablePoP StructType
 * @subpackage Structs
 */
class NNICapablePoP extends Address
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Reference
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Reference;
    /**
     * The Ports
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Ports;
    /**
     * Constructor method for NNICapablePoP
     * @uses NNICapablePoP::setName()
     * @uses NNICapablePoP::setReference()
     * @uses NNICapablePoP::setPorts()
     * @param string $name
     * @param string $reference
     * @param \ArrayType\ArrayOfString $ports
     */
    public function __construct($name = null, $reference = null, \ArrayType\ArrayOfString $ports = null)
    {
        $this
            ->setName($name)
            ->setReference($reference)
            ->setPorts($ports);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\NNICapablePoP
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Reference value
     * @return string|null
     */
    public function getReference()
    {
        return $this->Reference;
    }
    /**
     * Set Reference value
     * @param string $reference
     * @return \StructType\NNICapablePoP
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference, true), gettype($reference)), __LINE__);
        }
        $this->Reference = $reference;
        return $this;
    }
    /**
     * Get Ports value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getPorts()
    {
        return $this->Ports;
    }
    /**
     * Set Ports value
     * @param \ArrayType\ArrayOfString $ports
     * @return \StructType\NNICapablePoP
     */
    public function setPorts(\ArrayType\ArrayOfString $ports = null)
    {
        $this->Ports = $ports;
        return $this;
    }
}
